/************************************************************
3217 Phoenixville Pike
Malvern, PA  19355
800 321-5355 or 610 725-8800
http://www.lawsonlabs.com
VC++ demo. program for M40x A/D board,
Uses DLL: M40x.DLL to access M401
*************************************************************/


// M40xVC.h : main header file for the M40XVCAPP application
//

#if !defined(AFX_M40XVCAPP_H__DEFB43FC_1E1A_4E23_974C_40298F78FDBA__INCLUDED_)
#define AFX_M40XVCAPP_H__DEFB43FC_1E1A_4E23_974C_40298F78FDBA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif
#include "resource.h"		// main symbols
#include "M40xDef.h"
#include "M40xDlg.h"
#define MAX_M401  8		//max number of M401s this demo application can support

typedef RETURN_CODE (*P_DLL_GETLASTERROR) (SSCAN_OBJ *pScan_Obj);
typedef BOOLEAN(*P_DLL_OPENCONNECTION)(SSCAN_OBJ *pScan_Obj,LPCTSTR lp_addr, int port);
typedef void(*P_DLL_CLOSECONNECTION)(SSCAN_OBJ *pScan_Obj);
typedef RETURN_CODE(*P_DLL_SETRATE)(SSCAN_OBJ *pScan_Obj,double* fRate);
typedef RETURN_CODE (*P_DLL_SETCHAN)(SSCAN_OBJ *pScan_Obj,BYTE bChan);
typedef RETURN_CODE (*P_DLL_ENDSCAN)(SSCAN_OBJ *pScan_Obj);
typedef	RETURN_CODE (*P_DLL_SETDIGOUT)(SSCAN_OBJ *pScan_Obj,BYTE bDigOutByte);
typedef	RETURN_CODE (*P_DLL_SETRTC)(SSCAN_OBJ *pScan_Obj);
typedef	RETURN_CODE (*P_DLL_STARTSCAN)(SSCAN_OBJ *pScan_Obj,BYTE bScanMode,BYTE bChanNum);
typedef	RETURN_CODE (*P_DLL_GETPOLLEDCONV)(SSCAN_OBJ *pScan_Obj,double* fConvReading,BYTE *bLastDigIn);
typedef	RETURN_CODE (*P_DLL_OFSCAL)(SSCAN_OBJ *pScan_Obj,double* fOfsReading);
typedef	RETURN_CODE (*P_DLL_FSCAL)(SSCAN_OBJ *pScan_Obj,double* fFsReading);
typedef	RETURN_CODE (*P_DLL_GETSELFTESTRST)(SSCAN_OBJ *pScan_Obj,char* bRetString);
typedef	RETURN_CODE (*P_DLL_SETNEWIPADDR)(SSCAN_OBJ *pScan_Obj,UINT32 ulNewIPAddr, UINT32 ulNewNetMask, UINT32 ulNewGateWay,BYTE bDHCPTmOut);
typedef	BOOLEAN (*P_DLL_SETCALLBACKFUNC)(SSCAN_OBJ *pScan_Obj,void (CALLBACK EXPORT* lpGetBlock)(void));
typedef	void (*P_DLL_RESETSCANDATAOBJ)(SSCAN_OBJ *pScan_Obj,BYTE bScanMode, BYTE bSelChan,BYTE bRunningAvg,double fScanRate);
typedef	void (*P_DLL_RESETMINMAX)(SSCAN_OBJ *pScan_Obj);
typedef	BOOLEAN (*P_DLL_PTRTRANSFER)(SSCAN_VOLTS_BUFF* pScan_v_buff,SSCAN_OBJ* pScanObj);
typedef BOOLEAN (*P_DLL_GETSCANDATA)(SSCAN_OBJ *pScan_Obj);
typedef BOOLEAN (*P_DLL_NOCALLBACK)(SSCAN_OBJ *pScan_Obj);
//07.02.03
typedef BOOLEAN (*P_DLL_READSCANDATA)(SSCAN_OBJ *pScan_Obj, UINT *uNumPointsToRead);
typedef void (*P_DLL_EXIT)();
//11.24.2003.
typedef BOOLEAN (*P_DLL_NETWORKEVENTTHREAD)(SSCAN_OBJ *pScanObj);
typedef void (*P_DLL_SETTHREADPRIORITY) (BYTE bThreadType, BYTE bThreadPriority);
typedef BOOLEAN (*P_DLL_READEXSCANDATADBL)(SSCAN_OBJ* pScanObj,double *plDataBuff,BYTE *pbDigInp,UINT uiNumScansToReturn,UINT* puiNumScansReturned,UINT* puiNumScansInBuff);
typedef BOOLEAN (*P_DLL_GETMINMAXEFFBITS)(SSCAN_OBJ* pScanObj,double *pfMin, double *pfMax, double *pfEffBits);
typedef BOOLEAN (*P_DLL_EXTENDEDSCAN)(SSCAN_OBJ* pScanObj, LONG lAD0FirstChan, LONG lAD0LastChan, LONG lAD1FirstChan, LONG lAD1LastChan,BOOLEAN flgAD6, BOOLEAN flgAD7, BOOLEAN flgCalibration,BOOLEAN flgMuxInverted);
typedef RETURN_CODE (*P_DLL_GETSCANTIME)(SSCAN_OBJ* pScanObj, char *pStartTime, char *pStopTime, double *pfScanTime);
typedef RETURN_CODE (*P_DLL_GETTIMEDIFF)(SSCAN_OBJ* pScanObj,ULONG *pDiff);
typedef BOOLEAN (*P_DLL_ISFIRMWAREVERSION)(SSCAN_OBJ* pScanObj, int nMonth, int nDay, int nYear);



//typedef UINT (*P_DLL_TXBLOCKSIZE);
//typedef UINT (*P_DLL_REVDATAPOINTS);
//typedef	SSCAN_OBJ	(*P_DLL_SSCAN_OBJ);
//typedef	SSCAN_VOLTS_BUFF	(*P_DLL_SSCAN_VOLTS_BUFF);
typedef const char* (*P_DLL_ERROR_MSG);
/////////////////////////////////////////////////////////////////////////////
// CM40xVCApp:
// See M40xVC.cpp for the implementation of this class
//
class CM40xVCApp : public CWinApp
{
public:
	CM40xVCDlg* pdlg;
	BOOL LoadFunctions(void);
	CM40xVCApp();
	HMODULE hLibM40xCPP;
	P_DLL_ISFIRMWAREVERSION pDLL_IsFirmwareVersion;
	P_DLL_OPENCONNECTION pDLL_OpenConnection;
	P_DLL_CLOSECONNECTION pDLL_CloseConnection;
	P_DLL_SETRATE	pDLL_SetRate;
	P_DLL_SETCHAN	pDLL_SetChan;
	P_DLL_ENDSCAN	pDLL_EndScan;
	P_DLL_SETDIGOUT	pDLL_SetDigOut;
	P_DLL_SETRTC	pDLL_SetRTC;
	P_DLL_STARTSCAN	pDLL_StartScan;
	P_DLL_GETPOLLEDCONV	pDLL_GetPolledConv;
	P_DLL_OFSCAL	pDLL_OfsCal;
	P_DLL_FSCAL		pDLL_FsCal;
	P_DLL_GETSELFTESTRST	pDLL_GetSelfTestRst;
	P_DLL_SETNEWIPADDR		pDLL_SetNewIPAddr;
	P_DLL_RESETSCANDATAOBJ	pDLL_ResetScanDataObj;
	P_DLL_SETCALLBACKFUNC	pDLL_SetCallBackFunc;
	P_DLL_RESETMINMAX	pDLL_ResetMinMax;
	P_DLL_PTRTRANSFER		pDLL_PtrTransfer;
	P_DLL_GETSCANDATA		pDLL_GetScanData;
	P_DLL_NOCALLBACK		pDLL_NoCallback;
	P_DLL_EXIT		pDLL_Exit;
	//07.02.03
	P_DLL_READSCANDATA	pDLL_ReadScanData;
	P_DLL_ERROR_MSG pDLL_Error_Msg;
	//11.24.2003
	P_DLL_NETWORKEVENTTHREAD pDLL_NetworkEventThread;
	P_DLL_SETTHREADPRIORITY pDLL_SetThreadPriority;
	P_DLL_READEXSCANDATADBL pDLL_ReadExScanDataDbl;
	P_DLL_GETMINMAXEFFBITS pDLL_GetMinMaxEffBits;
	P_DLL_EXTENDEDSCAN pDLL_ExtendedScan;
	P_DLL_GETLASTERROR pDLL_GetLastError;
	P_DLL_GETSCANTIME pDLL_GetScanTime;
	P_DLL_GETTIMEDIFF pDLL_GetTimeDiff;

	CMenu*		pMyMenu;
	SSCAN_VOLTS_BUFF	DLL_Scan_volts_buff[MAX_M401];		//one for each index
	SSCAN_OBJ	DLL_Scan_obj[MAX_M401];						//one for each index
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CM40xVCApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CM40xVCApp)
	afx_msg void OnConfigm40x();
	afx_msg void OnHelpContent();
	afx_msg void OnHelpSearch();
	afx_msg	void OnHelpIndex (); 
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	ReadNewExScanData(UINT uIndex);
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_M40XVCAPP_H__DEFB43FC_1E1A_4E23_974C_40298F78FDBA__INCLUDED_)
